$(document).ready(function() {
    // load inky story from exported js file
    var story = new inkjs.Story(storyContent);

    // set vars
    var savePoints = [];
    var scrolling = false;
 //   savePoints.push(story.state.toJson());
    var hasSave = true;
    console.log(story.state.ToJson())
    var storyText = "";
    var sectionColor = 0;
    var readTarget = 250;
    var frameCount = 100;
    var currentChoice = 0;

    //position dotted line for 'now' 
    $("#nowLine").css("top", String(readTarget)+"px")

    // initial save at blank state
    function saveStory() {
        storyState = story.state.ToJson();
        savePoints.push(storyState);
    }
    
    /*  create next sections of story
        log each save point as html attribute on section containers;  advance inky story until decision has to be made;  save current state - before deciding!;  make decision for next loop    */
    function continueStory() {
        
        scText = sectionColor.toString();
        sectionText = "<a class='undecided' style='color:rgb("+scText+","+scText+","+scText+")' data-g='"+scText+"' data-save='"+String(savePoints.length -1)+"' data-choice='" + String(currentChoice) + "'>";
  //      sectionColor = sectionColor + 100;

        while(story.canContinue) {
            txt = story.Continue()
            sectionText = sectionText + txt;
        }

        if(story.currentChoices.length > 0) {
            saveStory()
            story.ChooseChoiceIndex(currentChoice)   
        }

        sectionText = sectionText + "</a>"

        return sectionText;
    }
    
    // create story first time and insert as html
    while(story.canContinue) {
        storyText = storyText + continueStory()
    }

    $("#main-container p").html(storyText)
    $(".undecided").first().removeClass("undecided")

    var storySave = "";

    /* to change sections of story once created.
    find first element classed undecided;  load save point from html attr;  remove this and all following objects from doc;  make choice;  write next sections*/
    function changeStory(obj) {
        sectionColor = 0;
    //   obj = $(".undecided").first();
    //  story.ResetState()
        story.state.LoadJson(savePoints[parseInt(obj.data("save"))]);
     
        if(story.currentChoices.length > 0) {
            saveStory();
            currentChoice = parseInt(obj.attr('data-choice'));
            if(currentChoice == story.currentChoices.length -1) {
                currentChoice = 0;
            } else {
                currentChoice++
            }
            obj.attr('data-choice', String(currentChoice))
            story.ChooseChoiceIndex(currentChoice)
        }

        txt = continueStory(obj);
       /* while(story.canContinue) {
            txt = txt + continueStory()
        }
        /*obj.nextAll().remove();
        obj.remove();
        $("#main-container p").append(txt) */
        obj.html(txt)
        ready = true;
    }

    // for doing some sort of fade effect
    function fadeText(obj) {
        dif = obj.offset().top - readTarget;
        gap = obj.data("g")
        change = gap/dif;
        newVal = String(gap + change);
   //     console.log(newVal)
        obj.data("g", newVal);
        obj.css("color", "rgb("+newVal+","+newVal+","+newVal+")")
    }

    setInterval(function() {
      //  changeStory($(".undecided").first())
        if(scrolling) {
            step = 5;
            obj = $(".undecided").each(function() {
                interval = (window.innerHeight - readTarget) / 2
                changeSpeed = Math.round((window.innerHeight - $(this).offset().top + $(window).scrollTop()) / interval)
                changeSpeed = (changeSpeed==0) ? 1 : changeSpeed * step;
                if(frameCount % changeSpeed == 0) {
                    changeStory($(this))
                }
            })
            frameCount++
        }
    }, 42)

    // scroll binder to activate change function on scroll. undecided class removed when el reaches target.
    
    $(document).on("scroll", function() {
        scrolling = true;
        obj = $(".undecided").first();
        currentPos = obj.offset().top - $(window).scrollTop()
        if(currentPos < readTarget) {
            obj.removeClass("undecided")
        }
    })

    $(document).on("scrollend", function (){
        console.log('stop')
        scrolling = false;
    })

    /*
        if(ready) {
            ready = false;
            window.requestAnimationFrame(changeStory(obj));
/*
            changeSpeed = Math.floor((window.innerHeight - obj.offset().top) / 100) * 10
            changeSpeed = changeSpeed ? 1 : changeSpeed;
            if(frameCount % changeSpeed == 0) {
                window.requestAnimationFrame(changeStory(obj));
                frameCount++
            } */
 //       }
    
  //  }) 

   
})





